<?php 
/**
 * @package :Maths Captcha
 * @name : Liang
 * @ url:http://community.elgg.org/pg/profile/arsalanlee
 * @licnnce : GPL V2
 */
?>
<?php

	function testcaptcha_init()
	{
		global $CONFIG;
		
		require_once(dirname(__FILE__)."/models/model.php");
		
		// Register a function that provides some default override actions
		register_plugin_hook('actionlist', 'captcha', 'testcaptcha_actionlist_hook');
		
		// Register actions to intercept
		$actions = array();
		$actions = trigger_plugin_hook('actionlist', 'captcha', null, $actions);

		if (($actions) && (is_array($actions)))
		{
			foreach ($actions as $action)
				register_plugin_hook("action", $action, "testcaptcha_verify_action_hook",999);
		}
		
		register_elgg_event_handler('create', 'user', 'testcaptcha_mark_register');
	}
	
	function testcaptcha_mark_register($event, $object_type, $object)
	{
		if($object && $object instanceof ElggUser)
		{
			if($_SESSION['testcaptcha_verified']==1)
				$_SESSION['testcaptcha_verified'] = "1";
			else
				$_SESSION['testcaptcha_verified'] = "0";
			return $object->setMetaData('testcaptcha_verified', $_SESSION['testcaptcha_verified']);
		}
	}
	
	/**
	 * Verify a testcaptcha based on the input value entered by the user and the seed token passed.
	 *
	 * @param string $input_value
	 * @param string $seed_token
	 * @return bool
	 */
	function testcaptcha_verify_captcha($input_value, $seed_token)
	{
		if (strcasecmp($input_value, testcaptcha_generate_captcha($seed_token)) == 0)
			return true;
			
		//Creating forward url
		$username = get_input('username');
		$email = get_input('email');
		$name = get_input('name');
		$agreetoterms = get_input('agreetoterms');
		$qs = explode('?',$_SERVER['HTTP_REFERER']);
		$qs = $qs[0];
		$qs .= "?username=" . urlencode($username) . "&email=" . urlencode($email) . "&name=" . urlencode($name)."&agreetoterms=".$agreetoterms;
		
		register_error(elgg_echo('testcaptcha:captchafail'));
		forward($qs);
		return false;
	}
	
	/**
	 * Listen to the action plugin hook and check the testcaptcha.
	 *
	 * @param unknown_type $hook
	 * @param unknown_type $entity_type
	 * @param unknown_type $returnvalue
	 * @param unknown_type $params
	 */
	function testcaptcha_verify_action_hook($hook, $entity_type, $returnvalue, $params)
	{
		global $_SESSION;
		$token = get_input('captcha_token');
		$input = trim(strtolower(get_input('captcha_input')));
		
		$challenge = testcaptcha::getCaptchaChallengeById($token);
		list($challenge_id, $challenge_question, $challenge_answer) = $challenge;  
		$challenge_answer = trim(strtolower($challenge_answer));
		
		if ($challenge_answer==$input)
		{
			$_SESSION['testcaptcha_verified'] = 1;
			return true;
		}
		$_SESSION['testcaptcha_verified'] = 0;
		
		//Creating forward url
		$username = get_input('username');
		$email = get_input('email');
		$name = get_input('name');
		$agreetoterms = get_input('agreetoterms');
		$qs = explode('?',$_SERVER['HTTP_REFERER']);
		$qs = $qs[0];
		$qs .= "?username=" . urlencode($username) . "&email=" . urlencode($email) . "&name=" . urlencode($name)."&agreetoterms=".$agreetoterms;
		
		register_error(elgg_echo('testcaptcha:captchafail'));
		forward($qs);
		return false;
	}
	
	/**
	 * This function returns an array of actions the testcaptcha will expect a testcaptcha for, other plugins may
	 * add their own to this list thereby extending the use.
	 *
	 * @param unknown_type $hook
	 * @param unknown_type $entity_type
	 * @param unknown_type $returnvalue
	 * @param unknown_type $params
	 */
	function testcaptcha_actionlist_hook($hook, $entity_type, $returnvalue, $params)
	{
		if (!is_array($returnvalue))
			$returnvalue = array();
			
		$returnvalue[] = 'register';
		$returnvalue[] = 'user/requestnewpassword';
			
		return $returnvalue;
	}
	
	register_elgg_event_handler('init','system','testcaptcha_init');
?>